#ifndef LidarPerceptionSubDataWrapper_WRAPPER_HEADER_H
#define LidarPerceptionSubDataWrapper_WRAPPER_HEADER_H


#include "sub/SubDataWrapper.h"
#include "lidar_perception/executable.h"


template <typename DataType>
class LiDAR2LiDARPerception_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
        std::cout << "Received type data from LiDAR is: " << sample->header.stampHigh << std::endl;
    }
};

template <typename DataType>
class HesaiRight_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
        std::cout << "Received type data from LiDAR is: " << sample->header.stampHigh << std::endl;
    }
};


template <typename DataType>
class HesaiLeft_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
        std::cout << "Received type data from LiDAR is: " << sample->header.stampHigh << std::endl;
    }
};

template <typename DataType>
class SLAMLocalEgoOdom2SWC_SubDataWrapper : public SubDataWrapper<DataType>
{
private:
    dpc::SLAMLocalEgoOdom* _Odo_LP = nullptr;
public:
    void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
        _Odo_LP = (dpc::SLAMLocalEgoOdom*) ptr->Get();
            //std::cout<<"Received data from SLAM is: "<<sample->origin_id<<std::endl;
        }
    void GetData(dpc::SLAMLocalEgoOdom& data) {
        if (_Odo_LP)
            data = *(_Odo_LP);
    }
};

template <typename DataType>
class VED2LiDARPerception_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
        std::cout<<"Received data from VED is: "<<sample->LongAcc<<std::endl;
    }
};

template <typename DataType>
class INS_CAN2SWC_100HZ_2SWC_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
//        std::cout<<"Received data from CAN is: "<<sample-><<std::endl;
    }
};

template <typename DataType>
class IMU_CAN2SWC_100HZ_2SWC_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
//        std::cout<<"Received data from CAN is: "<<sample-><<std::endl;
    }
};

#endif
